/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.PropinsiDto;
import com.portofolio.service.PropinsiService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/propinsi")
public class PropinsiController extends LocaleController {
	@Lazy
	@Autowired
	private PropinsiService propinsiService;

	@ApiOperation("Api Untuk Menyimpan Propinsi")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody PropinsiDto entity, HttpServletRequest request) {
		Map<String, Object> result = propinsiService.save(entity);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Update Propinsi")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(
			@RequestParam(value = "kdPropinsi", required = true) Integer kdPropinsi,
			@RequestParam(value = "version", required = true) Integer version,
			@Valid @RequestBody PropinsiDto entity,
			HttpServletRequest request) {
		Map<String, Object> result = propinsiService.update(entity, kdPropinsi,version);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menghapus Propinsi Berdasarkan KdPropinsi")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> deleteById(
			@RequestParam(value = "kdPropinsi", required = true) Integer kdPropinsi,
			@RequestParam(value = "version", required = true) Integer version
			) {
		Map<String, Object> result = propinsiService.deleteById(kdPropinsi, version);
		return RestUtil.getJsonResponse(result);
	}

	@ApiOperation("Api Untuk Menampilkan Semua Propinsi")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> findAll(@RequestParam(value = "page", defaultValue = "1") Integer page,
			@RequestParam(value = "rows", defaultValue = stringAsIntegerMaxValue) Integer rows,
			@RequestParam(value = "dir", defaultValue = "namaPropinsi") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaPropinsi", required = false, defaultValue = "") String namaPropinsi,
			@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
		Map<String, Object> result = propinsiService.grid(page, rows, sort, dir, namaPropinsi, statusEnabled);
		return RestUtil.getJsonResponse(result);
	}
	

	@ApiOperation("Api Untuk Menampilkan Propinsi Berdasarkan kdPropinsi")
	@GetMapping("/findByKdPropinsi")
	public ResponseEntity<Map<String, Object>> findByKdPropinsi(@RequestParam(value = "kdPropinsi", required = true) Integer kdPropinsi) {
		Map<String, Object> result = propinsiService.findByKdPropinsi(kdPropinsi);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Menampilkan Propinsi Berdasarkan kdNegara")
	@GetMapping("/findByKdNegara")
	public ResponseEntity<Map<String, Object>> findByKdNegara(@RequestParam(value = "kdNegara", required = true) Integer kdNegara) {
		Map<String, Object> result = propinsiService.findByKdNegara(kdNegara);
		return RestUtil.getJsonResponse(result);
	}

}
